package fr.atlantique.imt.ueirs6.comrec.main;

import java.util.*;

import fr.atlantique.imt.ueirs6.comrec.model.*;
import jakarta.persistence.EntityManager;
import jakarta.persistence.EntityManagerFactory;
import jakarta.persistence.Persistence;

public class Main {

	private EntityManagerFactory emf;

	public Main(int choice, Scanner in) {

		// Create the EntityManagerFactory
		emf = Persistence.createEntityManagerFactory("comrec-persistence-unit");
		EntityManager em = emf.createEntityManager();

		try {

			switch (choice) {
				case 1:
					createDepartments(em); // Create departments
					break;

				case 2:
					// createDepartments(em); // Create departments
					// createEmployees(em); // Create employees
					break;
				default:
					System.out.print("Wrong choice");
					break;
			}

		} finally {
			in.close();
			em.close(); // Important: Close the EntityManager
			emf.close(); // Also close the EntityManagerFactory. No longer needed
			System.out.println("\n======= End of the application =======");
			System.exit(0);
		}
	}

	public static void main(String[] args) {

		Scanner in = new Scanner(System.in);
		int choice = 0; // , empno, commission;

		System.out.println("\n======= Beginning of the application =======");
		System.out.println(
				"Execution level selection: \n\t Press 1 to create departments,\n\t Press 2 to create departments and employees.");

		choice = in.nextInt();

		new Main(choice, in);
	}

	/*
	 * Create departments in memory and persist them in the database
	 */
	public void createDepartments(EntityManager em) {

		System.out.println("\n-- Start departments creation --");

		Dept accounting, research, sales;

		System.out.println("==== Create departments in memory ====\n");
		accounting = new Dept("ACCOUNTING", "NEW YORK US");
		research = new Dept("RESEARCH", "DALLAS US");
		sales = new Dept("SALES", "CHICAGO US");

		System.out.println("===== Persist departments data ====\n ");
		em.getTransaction().begin();
		try {
			em.persist(accounting);
			em.persist(research);
			em.persist(sales);
			em.getTransaction().commit();
		} catch (Exception e) {
			em.getTransaction().rollback();
			e.printStackTrace();
		} finally { // Either if new departments are created or not, display the departments
			System.out.println("===== Display departments data =====");
			System.out.println(em.createNativeQuery("select d from departments d").getResultList());
		}
	}

	/*
	 * Create employees in memory and persist them in the
	 * database
	 */
	public void createEmployees() {
		// TODO
	}
}