package fr.atlantique.imt.ueirs6.comrec.model;

import jakarta.persistence.*;

/**
 * Entity implementation class for Entity: Dept
 * 
 */
@Entity
@Table(name = "departments")
public class Dept {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "dept_no")
	private Integer deptNumber;

	private String dName;

	@Column(name = "dept_loc")
	private String location;

	/*
	 * No argument constructor. Needed for persistence
	 */
	public Dept() {
	}

	/*
	 * Constructor for the class
	 */
	public Dept(String dname, String location) {
		this.setDName(dname);
		this.setLocation(location);
	}

	// ------------------------------------------------------
	// Getter methods

	public Integer getDeptNumber() {
		return this.deptNumber;
	}

	public String getDName() {
		return this.dName;
	}

	public String getLocation() {
		return this.location;
	}

	// ------------------------------------------------------
	// Setter methods

	public void setDeptNumber(Integer deptNumber) {
		this.deptNumber = deptNumber;
	}

	public void setDName(String dName) {
		this.dName = dName;
	}

	public void setLocation(String location) {
		this.location = location;
	}

	// ------------------------------------------------------

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((deptNumber == null) ? 0 : deptNumber.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Dept other = (Dept) obj;
		if (deptNumber == null) {
			if (other.deptNumber != null)
				return false;
		} else if (!deptNumber.equals(other.deptNumber))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "Dept [deptNumber=" + deptNumber + ", dName=" + dName + ", location=" + location + "]";
	}
}